#<profile4xi profile = "11" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_dummy_process4xi.py">
#<abstract4xi abstract = "tests dummy_process4xi"/>
#<refer4xi reference = "DragonXi"/>
#<verify4xi verification = "10" target = "dummyprocess4xi.py"/>
#<contextualize4xi context = "process4xi.py; current_process4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# ------------------------------------------------------------------------------------------------- 

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'main',
            'print_trace4xi',
            'set_trace4xi',
            'f4xi',
            'f2xi',
            'f']
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
               # system ones
import os
import sys
import signal

               # threading ones       
import threading                
import _thread
import _winapi
   

               # most-common ones
import time         
from time import gmtime, strftime 

               # rare ones
import datetime

       
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "

from dummyprocess4xi import DummyProcess4Xi

from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi      

from print4xi import Print4Xi
from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>

# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
        'DummyProcess4Xi': 'NACK4TRACE'
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>      


# -------------------------------------------------------------------------------------------------
#<function4xi function = "f4xi" usage = "
# Step 3/3 hello world from Dragon4Xi Multiprocessing4xi!
#">                         
# ------------------------------------------------------------------------------------------------- 

def f4xi():
    print ('(Step 3/3) Hello from Dummy Process4Xi of dragonized Multiprocessing4xi!')     
#</function4xi>
 

 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   printing trace
#">                    
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-dummy-process4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Dummy Process in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Dummy Process in Multiprocessing.</rdfs:comment>\n'}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-dummy-process4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Dummy Process in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations Dummy Process in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n'}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-dummy-process4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Dummy Process in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Dummy Process in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n'}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
  

    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main of dummy_process4xi
#">                               
# -------------------------------------------------------------------------------------------------           
def main(argv=None):
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 1/33) OF TEST_DUMMY_PROCESS4XI - SET T2XI TO: ", t2xi)
    # 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:
        # -----------------------------------------------------------------------------------------    
        # (Step 3/3a) - OK
        # -----------------------------------------------------------------------------------------      
        ack2process = False
        
        print("(STEP 3/3a1 OF TEST_DUMMY_PROCESS4XI) - CREATING A DUMMY PROCESS4XI ", time4xi())  
        # 01:43:38 01/14/13 Pacific Standard Time
        try:
            p2xi = DummyProcess4Xi(target=f4xi)
            print("(STEP 3/3a2 OF TEST_DUMMY_PROCESS4XI) CREATED DUMMY_PROCESS4XI OBJECT p2xi: ", p2xi)  
            # <DummyProcess4Xi(Thread-1, initial)>
            
            ack2process = True
            
        except:
            print("(STEP 3/3az OF TEST_DUMMY_PROCESS4XI) *** FAILED TO CREATE DUMMY_PROCESS4XI OBJECT ack2process: ", ack2process)
              
        
        # -----------------------------------------------------------------------------------------    
        # (Step 3/3b) - OK
        # -----------------------------------------------------------------------------------------          
        ack2start = False
        
        if ack2process is True:
            print("(STEP 3/3b1 OF TEST_DUMMY_PROCESS4XI) STARTING THE DUMMY PROCESS4XI ", time4xi())  
            # 01:43:38 01/14/13 Pacific Standard Time
            try:      
            
                p2xi.start() 
                print("(Step 3/3b2 OF TEST_DUMMY_PROCESS4XI) STARTED THE DUMMY PROCESS4XI p2xi: ", p2xi)
                # <DummyProcess4Xi(Thread-1, stopped 2148)>
                # (Step 3/3) Hello from Dummy Process4Xi of dragonized Multiprocessing4xi!
                ack2start = True
                    
            except:
                print("(STEP 3/3b3 OF TEST_DUMMY_PROCESS4XI) *** FAILED TO START THE DUMMY PROCESS4XI p2xi: ", p2xi)
        else:
            print("(STEP 3/3bz OF TEST_DUMMY_PROCESS4XI) ** YIELDED STARTING THE DUMMY PROCESS4XI ack2process: ", ack2process)
    
    
        # -----------------------------------------------------------------------------------------    
        # (Step 3/3f) - OK 
        # -----------------------------------------------------------------------------------------             
        ack2alive = False
        if ack2start is True:
        
            try:
                print("( Step 3/3f1 OF TEST_DUMMY_PROCESS4XI) DUMMY PROCESS4XI ALIVE STATUS: ", p2xi.is_alive()) 
                #False
                ack2alive = True
            except:
                print("(STEP 3/3f2 OF TEST_DUMMY_PROCESS4XI) *** FAILED TO CHECK ALIVE STATE ack2alive: ", ack2alive)
        else:
            print("(STEP 3/3fz OF TEST_DUMMY_PROCESS4XI) ** YIELDED CHECKING ALIVE STATE ack2start: ", ack2start)          
        
     
        
        # -----------------------------------------------------------------------------------------    
        # SENSE - OK
        # -----------------------------------------------------------------------------------------             
        ack2sense = False
        
        if ack2process is True:
            try:   
                print("(Step 3/3g1 OF TEST_DUMMY_PROCESS4XI) SENSED: ", p2xi.sense())
                # {'object': <DummyProcess4Xi(Thread-1, stopped 2148)>}
                ack2sense = True
            except:
                print("(STEP 3/3g2 OF TEST_DUMMY_PROCESS4XI) *** FAILED TO SENSE THE DUMMY PROCESS4XI p2xi: ", p2xi)
        else:
            print("(STEP 3/3gz OF TEST_DUMMY_PROCESS4XI) ** YIELDED SENSING THE DUMMY PROCESS4XI ack2sense: ", ack2sense)
                
                
        
        
        
        # -----------------------------------------------------------------------------------------    
        # REASON - OK
        # -----------------------------------------------------------------------------------------          
        ack2reason = False
        
        if ack2process is True:
            try:   
                print("(Step 3/3h1 OF TEST_DUMMY_PROCESS4XI) REASONED: ", p2xi.reason())
                # {'object-reason-object4xi': <DummyProcess4Xi(Thread-1, stopped 2148)>}
                ack2reason = True
            except:
                print("(STEP 3/3h2 OF TEST_DUMMY_PROCESS4XI) *** FAILED TO REASON THE DUMMY PROCESS4XI p2xi: ", p2xi)
        else:
            print("(STEP 3/3hz OF TEST_DUMMY_PROCESS4XI) ** YIELDED REASONING THE DUMMY PROCESS4XI ack2reason: ", ack2reason)
              
        
        # -----------------------------------------------------------------------------------------    
        # ACE - OK
        # -----------------------------------------------------------------------------------------          
        ack2ace = False
        
        if ack2process is True:
            try:   
                print("(Step 3/3i1 OF TEST_DUMMY_PROCESS4XI) ACED: ", p2xi.reason())
                # {'object-reason-object4xi': <DummyProcess4Xi(Thread-1, stopped 2148)>}
                ack2ace = True
            except:
                print("(STEP 3/3i2 OF TEST_DUMMY_PROCESS4XI) *** FAILED TO ACE THE DUMMY PROCESS4XI p2xi: ", p2xi)
        else:
            print("(STEP 3/3iz OF TEST_DUMMY_PROCESS4XI) ** YIELDED ACING THE DUMMY PROCESS4XI ack2ace: ", ack2ace)
              
        # -----------------------------------------------------------------------------------------    
        # (Step 3/3j) - OK .i.e. you can NOT run a terminated process !
        # -----------------------------------------------------------------------------------------          
        ack2run = False
        
        if ((ack2process is True) and (p2xi.is_alive() is True)):
            print("(STEP 3/3j1 OF TEST_DUMMY_PROCESS4XI) RUN THE DUMMY PROCESS4XI p2xi: ", p2xi)
            # <DummyProcess4Xi(Thread-1, stopped 2148)>
            try:   
                p2xi.run()
                
                ack2run = True
                
            except:
                print("(STEP 3/3j2 OF TEST_DUMMY_PROCESS4XI) ** YIELDED - YOU CAN NOT RUN STOPPED PROCESS4XI p2xi: ", p2xi)
                # ** YIELDED - YOU CAN NOT RUN STOPPED PROCESS4XI p2xi:  <DummyProcess4Xi(Thread-1, stopped 2148)>
                
        else:
            print("(STEP 3/3jz OF TEST_DUMMY_PROCESS4XI) ** YIELDED BECAUSE YOU CAN NOT RUN A TERMINATED PROCESS: ", ack2run)
            # YIELDED BECAUSE YOU CAN NOT RUN A TERMINATED PROCESS:  False  
        
        # -----------------------------------------------------------------------------------------    
        # (Step 3/3k) - OK because a dummy process has no boot method ! 
        # -----------------------------------------------------------------------------------------     
             
        if ((ack2process is True) and (p2xi.is_alive() is True)):
            print("(STEP 3/3k1 OF TEST_DUMMY_PROCESS4XI) BOOT THE DUMMY PROCESS4XI p2xi: ", p2xi)
            # <DummyProcess4Xi(Thread-1, stopped 2148)>    
            try:    
                p2xi._bootstrap()
                
                print("(STEP 3/3k2 OF TEST_DUMMY_PROCESS4XI) BOOTED THE DUMMY PROCESS4XI p2xi: ", p2xi)
                
                ack2boot = True
                
            except:
                print("(STEP 3/3kz OF TEST_DUMMY_PROCESS4XI) ** YIELDED BOOTING THE DUMMY PROCESS4XI p2xi: ", p2xi)
                # <DummyProcess4Xi(Thread-1, stopped 1644)>
        else:
            ack2boot = False
            print("(STEP 3/3k4 OF TEST_DUMMY_PROCESS4XI) ** YIELDED BECAUSE YOU CAN NOT BOOT TERMINATED DUMMY PROCESS, ACK2BOOT ", ack2boot)
            # ** YIELDED BECAUSE YOU CAN NOT BOOT TERMINATED DUMMY PROCESS, ACK2BOOT  False
            
        # -----------------------------------------------------------------------------------------    
        # (Step 3/3l)
        # -----------------------------------------------------------------------------------------          
              
        if ((ack2process is True) and (p2xi.is_alive() is True)):
            print("(STEP 3/3l1 OF TEST_DUMMY_PROCESS4XI) TERMINATE THE DUMMY PROCESS4XI p2xi: ", p2xi)
            try:   
                p2xi.terminate()
                
                ack2terminate = True
            except:
                print("(STEP 3/3lz OF TEST_DUMMY_PROCESS4XI) ** YIELDED TERMINATING THE DUMMY PROCESS4XI p2xi: ", p2xi)
                # *** FAILED TO TERMINATE THE DUMMY PROCESS4XI p2xi:  <DummyProcess4Xi(Thread-1, stopped 1824)>
        else:
            ack2terminate = False
            print("(STEP 3/3l4 OF TEST_DUMMY_PROCESS4XI** YIELDED TERMINATING THE DUMMY PROCESS4XI, ACK2TERMINATE: ", ack2terminate)
            # ** YIELDED TERMINATING THE DUMMY PROCESS4XI, ACK2TERMINATE:  False  
            
        # -----------------------------------------------------------------------------------------    
        # (Step 3/3m) - COMPLETED ALL TESTS  
        # -----------------------------------------------------------------------------------------
        print("(Step 3/3m1 OF TEST_DUMMY_PROCESS4XI) - ALL STEPS OF DUMMY PROCESS4XI TEST HAVE BEEN COMPLETED! ", time4xi())
        # 
        if ((ack2process is True) and (ack2alive) and (ack2terminate is True) and (ack2run is True) and (ack2sense is True) and (ack2reason is True) and (ack2ace is True) and (ack2boot is True)):
            print("(Step 3/3m2 OF TEST_DUMMY_PROCESS4XI) - ACK FROM YOUR DRAGONXI ! ", time4xi())
        else:
            print("(Step 3/3m3 OF TEST_DUMMY_PROCESS4XI) - NOTES ", time4xi()) 
            print("ACK2PROCESS: ", ack2process)
            print("ACK2ALIVE: ", ack2alive)
            print("ACK2TERMINATE: ", ack2terminate, " - OK, YOU TRIED TO TERMINATE STOPPED PROCESS! ", time4xi())
            print("ACK2RUN: ", ack2run)
            print("ACK2BOOT: ", ack2boot, " - OK, DUMMYPROCESS4XI DOES NOT HAVE _BOOTSTRAP IMPLEMENTED! ", time4xi())
            print("ACK2SENSE: ", ack2sense)
            print("ACK2REASON: ", ack2reason)
            print("ACK2ACE: ", ack2ace)
            
    finally:    
        
        # ---------------------------------------------------------------------------------------------    
        # PRINT TRACE
        # ---------------------------------------------------------------------------------------------     
        print_trace4xi(t2xi)        
#</function4xi>

# -------------------------------------------------------------------------------------------------
#                               
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    
   
    main()
      
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_dummy_process4xi.txt
#   sense-dummy-process4xi.xml
#   reason-dummy-process4xi.xml
#   ace-dummy-process4xi.xml

# ------------------------------------------------------------------------------------------------- 
#Test 11:05:44 03/18/10 FLE Standard Time:
# *** TO BE SOLVED FOR YOUR DRAGONXI ***
# ACK2PROCESS:  True
# ACK2ALIVE:  True
# ACK2TERMINATE:  False  - False might be ok, if you tried to terminate stopped process!
# ACK2RUN:  False
# ACK2BOOT:  False  - False might be ok, if DummyProcess4Xi does not _bootstrap implemented!
# ACK2SENSE:  True
# ACK2REASON:  True
# ACK2ACE:  True
# ------------------------------------------------------------------------------------------------- 
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_dummy_process4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>

    